Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/StructuresSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/StructuresSection.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/StructuresSection.java	(revision 3422)
@@ -0,0 +1,101 @@
+package org.txm.rcp.editors.imports.sections;
+
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Text;
+import org.eclipse.ui.forms.events.ExpansionAdapter;
+import org.eclipse.ui.forms.events.ExpansionEvent;
+import org.eclipse.ui.forms.widgets.FormToolkit;
+import org.eclipse.ui.forms.widgets.ScrolledForm;
+import org.eclipse.ui.forms.widgets.TableWrapData;
+import org.eclipse.ui.forms.widgets.TableWrapLayout;
+import org.txm.objects.Project;
+import org.txm.rcp.editors.imports.ImportFormEditor;
+import org.txm.rcp.messages.TXMUIMessages;
+
+public class StructuresSection extends ImportEditorSection {
+	
+	private static final int SECTION_SIZE = 1;
+	
+	private Text milestoneElementsText;
+
+	private Text projectionsText;
+	
+	public StructuresSection(ImportFormEditor editor, FormToolkit toolkit2, ScrolledForm form2, Composite parent, int style) {
+		super(editor, toolkit2, form2, parent, style, "structures");
+		
+		this.section.setText("Structures");
+		TableWrapLayout layout = new TableWrapLayout();
+		layout.makeColumnsEqualWidth = true;
+		this.section.setLayout(layout);
+		this.section.setLayoutData(getSectionGridData(SECTION_SIZE));
+		this.section.setEnabled(false);
+		this.section.addExpansionListener(new ExpansionAdapter() {
+			
+			@Override
+			public void expansionStateChanged(ExpansionEvent e) {
+				form.layout(true);
+			}
+		});
+		
+		Composite sectionClient = toolkit.createComposite(this.section);
+		TableWrapLayout slayout = new TableWrapLayout();
+		slayout.makeColumnsEqualWidth = false;
+		slayout.numColumns = 2;
+		sectionClient.setLayout(slayout);
+		this.section.setClient(sectionClient);
+		
+		Label tmpLabel4 = toolkit.createLabel(sectionClient, TXMUIMessages.milestoneElements);
+		tmpLabel4.setToolTipText(TXMUIMessages.listOfMilestoneElementsSeparatedByComma);
+		tmpLabel4.setLayoutData(getLabelGridData());
+		
+		milestoneElementsText = toolkit.createText(sectionClient, "", SWT.BORDER); //$NON-NLS-1$
+		TableWrapData gdata = getTextGridData();
+		milestoneElementsText.setLayoutData(gdata);
+		
+		Label label = toolkit.createLabel(sectionClient, "CQP Structure properties projections", SWT.WRAP);
+		gdata = getLabelGridData();
+		gdata.colspan = 2;
+		label.setLayoutData(gdata);
+		
+		projectionsText = toolkit.createText(sectionClient, "", SWT.BORDER | SWT.MULTI | SWT.V_SCROLL); //$NON-NLS-1$
+		gdata = getTextGridData();
+		gdata.heightHint = 50;
+		gdata.colspan = 2;
+		
+		projectionsText.setLayoutData(gdata);
+	}
+	
+	@Override
+	public void updateFields(Project project) {
+		if (this.section != null && !section.isDisposed()) {
+			milestoneElementsText.setText(project.getTextualPlan("MileStones"));
+			projectionsText.setText(project.getTextualPlan("Projections"));
+		}
+	}
+	
+	@Override
+	public boolean saveFields(Project project) {
+		if (this.section != null && !section.isDisposed()) {
+			
+			project.setTextualPlan("MileStones", milestoneElementsText.getText().trim());
+			
+			project.setTextualPlan("Projections", projectionsText.getText().trim());
+			
+			return true;
+		}
+		
+		return true;
+	}
+	
+	@Override
+	public boolean checkFields() {
+		return true;
+	}
+	
+	@Override
+	public int getSectionSize() {
+		return SECTION_SIZE;
+	}
+}

Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/CorpusPage.java	(revision 3422)
@@ -70,8 +70,9 @@
 import org.txm.rcp.editors.imports.sections.InfosSection;
 import org.txm.rcp.editors.imports.sections.LangSection;
 import org.txm.rcp.editors.imports.sections.OptionsSection;
+import org.txm.rcp.editors.imports.sections.StructuresSection;
 import org.txm.rcp.editors.imports.sections.TextualPlansSection;
-import org.txm.rcp.editors.imports.sections.TokenizerSection;
+import org.txm.rcp.editors.imports.sections.WordsSection;
 import org.txm.rcp.handlers.scripts.ExecuteImportScript;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.rcp.utils.SWTEditorsUtils;
@@ -121,6 +122,8 @@
 	
 	ImportEditorSection textualPlansSection;
 	
+	ImportEditorSection structuresSection;
+	
 	ImportEditorSection optionsSection;
 	
 	/**
@@ -211,7 +214,7 @@
 			N_SECTIONS += createLangSection();
 		}
 		
-		if (moduleParams.get(ImportModuleCustomization.TOKENIZER)) {
+		if (moduleParams.get(ImportModuleCustomization.WORDS)) {
 			N_SECTIONS += createTokenizerSection();
 		}
 		
@@ -235,6 +238,9 @@
 		if (moduleParams.get(ImportModuleCustomization.TEXTUALPLANS)) {
 			N_SECTIONS += createTextualPlansSection();
 		}
+		if (moduleParams.get(ImportModuleCustomization.STRUCTURES)) {
+			N_SECTIONS += createStructuresSection();
+		}
 		if (moduleParams.get(ImportModuleCustomization.OPTIONS)) {
 			N_SECTIONS += createOptionsSection();
 		}
@@ -264,6 +270,11 @@
 		return textualPlansSection.getSectionSize();
 	}
 	
+	private int createStructuresSection() {
+		structuresSection = new StructuresSection(editor, toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
+		return structuresSection.getSectionSize();
+	}
+	
 	private int createOptionsSection() {
 		optionsSection = new OptionsSection(editor, toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE);
 		return optionsSection.getSectionSize();
@@ -705,7 +716,7 @@
 	 * Creates the tokenizer section.
 	 */
 	private int createTokenizerSection() {
-		tokenizerSection = new TokenizerSection(editor, toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE, moduleParams);
+		tokenizerSection = new WordsSection(editor, toolkit, form, form.getBody(), ExpandableComposite.TITLE_BAR | ExpandableComposite.TWISTIE, moduleParams);
 		return tokenizerSection.getSectionSize();
 	}
 	
@@ -879,6 +890,11 @@
 			textualPlansSection.update(project);
 		}
 		
+		if (structuresSection != null && !structuresSection.isDisposed()) {
+			structuresSection.setEnabled(true);
+			structuresSection.update(project);
+		}
+		
 		if (optionsSection != null && !optionsSection.isDisposed()) {
 			optionsSection.setEnabled(true);
 			optionsSection.update(project);
@@ -958,6 +974,9 @@
 		if (textualPlansSection != null && !textualPlansSection.isDisposed()) {
 			doSave = doSave & textualPlansSection.check();
 		}
+		if (structuresSection != null && !structuresSection.isDisposed()) {
+			doSave = doSave & structuresSection.check();
+		}
 		if (optionsSection != null && !optionsSection.isDisposed()) {
 			doSave = doSave & optionsSection.check();
 		}
@@ -998,6 +1017,9 @@
 		if (textualPlansSection != null && !textualPlansSection.isDisposed()) {
 			successfulSave = successfulSave & textualPlansSection.save(project);
 		}
+		if (structuresSection != null && !structuresSection.isDisposed()) {
+			successfulSave = successfulSave & structuresSection.save(project);
+		}
 		if (optionsSection != null && !optionsSection.isDisposed()) {
 			successfulSave = successfulSave & optionsSection.save(project);
 		}
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportModuleCustomization.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportModuleCustomization.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/ImportModuleCustomization.java	(revision 3422)
@@ -27,7 +27,7 @@
 	
 	public static final String XSLT = "xslt"; //$NON-NLS-1$
 	
-	public static final String TOKENIZER = "tokenizer"; //$NON-NLS-1$
+	public static final String WORDS = "words"; //$NON-NLS-1$
 	
 	public static final String ADVANCEDTOKENIZER = "tokenizer-advanced"; //$NON-NLS-1$
 	
@@ -49,6 +49,8 @@
 	
 	public static final String TEXTUALPLANS = "textualplans";
 	
+	public static final String STRUCTURES = "structures";
+	
 	public static final String IMPORT_NAME = "import_name";
 	
 	public static HashMap<String, HashMap<String, Boolean>> sectionsPerImportModule = new HashMap<>();
@@ -63,7 +65,7 @@
 		params.put(ENCODING, true);
 		params.put(LANG, false);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, false);
+		params.put(WORDS, false);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -73,6 +75,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("discoursLoader.groovy", params); //$NON-NLS-1$
 		names.put("discoursLoader.groovy", "CNR + CSV"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -83,7 +86,7 @@
 		params.put(ENCODING, true);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -93,6 +96,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("cqpLoader.groovy", params); //$NON-NLS-1$
 		names.put("cqpLoader.groovy", "CQP"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -102,7 +106,7 @@
 		params.put(ENCODING, true);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, false);
+		params.put(WORDS, false);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -112,6 +116,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("hyperbaseLoader.groovy", params); //$NON-NLS-1$
 		names.put("hyperbaseLoader.groovy", "Hyperbase"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -121,7 +126,7 @@
 		params.put(ENCODING, true);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -131,6 +136,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("alcesteLoader.groovy", params); //$NON-NLS-1$
 		names.put("alcesteLoader.groovy", "Alceste"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -140,7 +146,7 @@
 		params.put(ENCODING, true);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -150,6 +156,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("txtLoader.groovy", params); //$NON-NLS-1$
 		names.put("txtLoader.groovy", "TXT + CSV"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -159,7 +166,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, true);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -169,6 +176,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, true);
+		params.put(STRUCTURES, true);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("transcriberLoader.groovy", params); //$NON-NLS-1$
 		names.put("transcriberLoader.groovy", "XML-TRS + CSV"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -178,7 +186,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -188,6 +196,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("tmxLoader.groovy", params); //$NON-NLS-1$
 		names.put("tmxLoader.groovy", "XML-TMX"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -197,7 +206,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, true);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -207,6 +216,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("xmlLoader.groovy", params); //$NON-NLS-1$
 		names.put("xmlLoader.groovy", "XML/w + CSV"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -216,7 +226,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -226,6 +236,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("xmltxmLoader.groovy", params); //$NON-NLS-1$
 		names.put("xmltxmLoader.groovy", "XML-TEI TXM"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -235,7 +246,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -245,6 +256,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("factivaLoader.groovy", params); //$NON-NLS-1$
 		names.put("factivaLoader.groovy", "XML-PPS"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -254,7 +266,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -264,6 +276,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("factivamailLoader.groovy", params); //$NON-NLS-1$
 		names.put("factivamailLoader.groovy", "Factiva TXT"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -273,7 +286,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -283,6 +296,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("bfmLoader.groovy", params); //$NON-NLS-1$
 		names.put("bfmLoader.groovy", "XML-TEI BFM"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -292,7 +306,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, true);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, false);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, false);
@@ -302,6 +316,7 @@
 		params.put(QUERIES, true);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, false);
+		params.put(STRUCTURES, false);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("frantextLoader.groovy", params); //$NON-NLS-1$
 		names.put("frantextLoader.groovy", "XML-TEI Frantext"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -311,7 +326,7 @@
 		params.put(ENCODING, false);
 		params.put(LANG, true);
 		params.put(XSLT, false);
-		params.put(TOKENIZER, true);
+		params.put(WORDS, true);
 		params.put(ADVANCEDTOKENIZER, true);
 		params.put(EDITIONS_WORDSPERPAGE, true);
 		params.put(EDITIONS_PAGEELEMENT, true);
@@ -321,6 +336,7 @@
 		params.put(QUERIES, false);
 		params.put(UI, true);
 		params.put(TEXTUALPLANS, true);
+		params.put(STRUCTURES, true);
 		params.put(OPTIONS, true);
 		sectionsPerImportModule.put("xtzLoader.groovy", params); //$NON-NLS-1$
 		names.put("xtzLoader.groovy", "XML-TEI Zero + CSV"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -360,7 +376,7 @@
 			params.put(ENCODING, true);
 			params.put(LANG, true);
 			params.put(XSLT, true);
-			params.put(TOKENIZER, true);
+			params.put(WORDS, true);
 			params.put(ADVANCEDTOKENIZER, false);
 			params.put(EDITIONS_WORDSPERPAGE, true);
 			params.put(EDITIONS_PAGEELEMENT, true);
@@ -370,6 +386,7 @@
 			params.put(QUERIES, true);
 			params.put(UI, true);
 			params.put(TEXTUALPLANS, false);
+			params.put(STRUCTURES, false);
 			params.put(OPTIONS, true);
 			return params;
 		}
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/messages/TXMUIMessages.java	(revision 3422)
@@ -1181,6 +1181,9 @@
 	public static String xmlTagNameThatEncodesWords;
 
 	public static String numberOfLines;
+
+	public static String tabulation;
+	public static String nothing;
 	
 	static {
 		// initialize resource bundle
Index: TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3421)
+++ TXM/trunk/org.txm.core/src/java/org/txm/objects/Project.java	(revision 3422)
@@ -1135,6 +1135,8 @@
 	@Override
 	public void clean() {
 		
+		Toolbox.notifyEngines(this, "before_clean"); // if an extension needs to free some files before
+		
 		if (rcpProject != null) {
 			try {
 				// Toolbox.getEngineManager(EngineType.SEARCH).getEngine("CQP").stop(); //$NON-NLS-1$
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java	(revision 3421)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/URSCorpora.java	(revision 3422)
@@ -106,7 +106,7 @@
 	/**
 	 * need the corpus to be loaded
 	 * 
-	 * @param name
+	 * @param mcorpus
 	 * @return the corpus Vue
 	 */
 	public static Vue getVue(CorpusBuild mcorpus) {
@@ -124,6 +124,18 @@
 	}
 	
 	/**
+	 * Has a Vue being loaded for a Corpusbuild
+	 * 
+	 * @param mcorpus
+	 * @return true if a Vue is loaded
+	 */
+	public static boolean hasVue(CorpusBuild mcorpus) {
+		mcorpus = mcorpus.getRootCorpusBuild(); // ensure this is the root CorpusBuild
+		
+		return vues.containsKey(mcorpus);
+	}
+	
+	/**
 	 * Save the associated AnalecCorpus
 	 * 
 	 * @param mcorpus
@@ -203,6 +215,11 @@
 			CorpusBuild mcorpus = (CorpusBuild) r;
 			mcorpus = mcorpus.getRootCorpusBuild(); // ensure this is the root CorpusBuild
 			
+			if (URSCorpora.hasCorpus(mcorpus)) {
+				Corpus analec_corpus = URSCorpora.getCorpus(mcorpus);
+				analec_corpus.fermer();
+			}
+
 			URSCorpora.removeCorpus(mcorpus);
 			
 			File fichierCorpus = new File(mcorpus.getProjectDirectory(), "analec/" + mcorpus.getID() + ".ec"); //$NON-NLS-1$ //$NON-NLS-2$
@@ -248,7 +265,7 @@
 	
 	@Override
 	public boolean hasAnnotationsToSave(CorpusBuild mcorpus) {
-		if (URSCorpora.hasCorpus(mcorpus)) return false; // no corpus instanced -> no annotations to save
+		if (!URSCorpora.hasCorpus(mcorpus)) return false; // no corpus instanced -> no annotations to save
 		return URSCorpora.getCorpus(mcorpus).isModifie();
 	}
 	
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitConcordanceToolbar.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitConcordanceToolbar.java	(revision 3421)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitConcordanceToolbar.java	(revision 3422)
@@ -408,7 +408,7 @@
 		onAnnotationTypeSelected(null);
 		
 		editor.layout(true);
-		ext.getSaveButton().setEnabled(true);
+//		ext.getSaveButton().setEnabled(true);
 		return true;
 	}
 	
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitToolbar.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitToolbar.java	(revision 3421)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/UnitToolbar.java	(revision 3422)
@@ -135,7 +135,7 @@
 			// this.selected_unit_color = new RGBA(selected_unit_color_pref, 1f);
 		}
 		
-		this.button = extension.getSaveButton();
+		//		this.button = extension.getSaveButton();
 		this.maincorpus = this.editor.getCorpus().getMainCorpus();
 		try {
 			maxCorpusPosition = maincorpus.getSize();
@@ -649,6 +649,7 @@
 	}
 	
 	public String uniteToWords(Unite unit) {
+		
 		AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
 		String[] firstWords = null;
 		try {
@@ -669,6 +670,7 @@
 	 * Highlight units of the current page
 	 */
 	protected synchronized void highlightType() {
+		
 		if (unites == null) return;
 		if (editor.getEditionPanels().size() == 0) return;
 		
@@ -690,13 +692,23 @@
 			int last_ids[] = null;
 			if (next != null && next != page) {
 				String nextPageWordID = next.getWordId();
-				last_ids = CQPSearchEngine.getCqiClient().str2Id(qid, new String[] { nextPageWordID });
+				if (!("w_0".equals(nextPageWordID))) {
+					last_ids = CQPSearchEngine.getCqiClient().str2Id(qid, new String[] { nextPageWordID });
+					if (last_ids.length == 0 || last_ids[0] == -1) {
+						Log.warning("No CQP id for word id="+nextPageWordID);
+					}
+				}
 			}
 			
 			int first_pos = CQPSearchEngine.getCqiClient().id2Cpos(qid, first_id)[0];
 			int last_pos = Integer.MAX_VALUE;
-			if (last_ids != null && last_ids.length > 0) {
-				last_pos = CQPSearchEngine.getCqiClient().id2Cpos(qid, last_ids[0])[0];
+			if (last_ids != null && last_ids.length > 0 && last_ids[0] != -1) {
+				int[] v = CQPSearchEngine.getCqiClient().id2Cpos(qid, last_ids[0]);
+				if (v.length == 0) {
+					Log.warning("No position found for CQP id="+last_ids[0]);
+				} else {
+					last_pos = v[0];
+				}
 			}
 			
 			int n2 = 0; // first loop to determine the allpositions array length
@@ -1258,7 +1270,7 @@
 	public boolean hasChanges() {
 		return analecCorpus.isModifie();
 	}
-
+	
 	@Override
 	public boolean needToUpdateEditions() {
 		
Index: TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/URSAnnotationToolbar.java
===================================================================
--- TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/URSAnnotationToolbar.java	(revision 3421)
+++ TXM/trunk/org.txm.analec.rcp/src/org/txm/annotation/urs/toolbar/URSAnnotationToolbar.java	(revision 3422)
@@ -71,7 +71,7 @@
 	
 	protected SynopticEditionEditor editor;
 	
-	protected ToolItem button;
+//	protected ToolItem button;
 	
 	private Button closeButton;
 
@@ -165,8 +165,8 @@
 			analecCorpus.ajouterProp(Unite.class, "Entity", "Property");
 		}
 		
-		button = extension.getSaveButton();
-		button.setEnabled(analecCorpus.isModifie());
+//		button = extension.getSaveButton();
+//		button.setEnabled(analecCorpus.isModifie());
 		
 		_install(txmeditor, extension, parent, position);
 		
@@ -278,33 +278,33 @@
 			
 			// System.out.println("StartButton.corpusListener.traiterEvent: "+e);
 			
-			button.getDisplay().syncExec(new Runnable() {
-				
-				@Override
-				public void run() {
-					if (e.getType() == TypeMessage.MODIF_STRUCTURE) {
-						boolean ready = URSCorpora.isAnnotationStructureReady(maincorpus);
-						button.setEnabled(ready);
-						// if (!ready && utoolbar != null && !utoolbar.isDisposed()) utoolbar.clearHighlight();
-					}
-					
-					if (e.getType() == TypeMessage.MODIF_ELEMENT) {
-						button.setEnabled(URSCorpora.isAnnotationStructureReady(maincorpus));
-						if (!maincorpus.isModified()) {
-							maincorpus.setIsModified(true); // to show the * in corpora view
-							updateCorporaView(maincorpus);
-						}
-						
-					}
-					else if (e.getType() == TypeMessage.CORPUS_SAVED) {
-						button.setEnabled(false);
-						if (maincorpus.isModified()) {
-							maincorpus.setIsModified(false); // to remove the * in corpora view
-							updateCorporaView(maincorpus);
-						}
-					}
-				}
-			});
+//			button.getDisplay().syncExec(new Runnable() {
+//				
+//				@Override
+//				public void run() {
+//					if (e.getType() == TypeMessage.MODIF_STRUCTURE) {
+//						boolean ready = URSCorpora.isAnnotationStructureReady(maincorpus);
+//						button.setEnabled(ready);
+//						// if (!ready && utoolbar != null && !utoolbar.isDisposed()) utoolbar.clearHighlight();
+//					}
+//					
+//					if (e.getType() == TypeMessage.MODIF_ELEMENT) {
+//						button.setEnabled(URSCorpora.isAnnotationStructureReady(maincorpus));
+//						if (!maincorpus.isModified()) {
+//							maincorpus.setIsModified(true); // to show the * in corpora view
+//							updateCorporaView(maincorpus);
+//						}
+//						
+//					}
+//					else if (e.getType() == TypeMessage.CORPUS_SAVED) {
+//						button.setEnabled(false);
+//						if (maincorpus.isModified()) {
+//							maincorpus.setIsModified(false); // to remove the * in corpora view
+//							updateCorporaView(maincorpus);
+//						}
+//					}
+//				}
+//			});
 			
 		}
 	};
@@ -380,6 +380,6 @@
 	
 	public void fireIsDirty() {
 		editor.fireIsDirty();
-		this.extension.getSaveButton().setEnabled(true);
+//		this.extension.getSaveButton().setEnabled(true);
 	}
 }
Index: TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/KRAnnotation.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/KRAnnotation.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/KRAnnotation.java	(revision 3422)
@@ -194,7 +194,7 @@
 			}
 		});
 		
-		ext.getSaveButton().setEnabled(true);
+//		ext.getSaveButton().setEnabled(true);
 		return composeAnnotationArea(parent);
 	}
 	
@@ -1050,7 +1050,7 @@
 	
 	@Override
 	public boolean isDirty() {
-		return annotManager != null;
+		return annotManager != null && annotManager.isDirty();
 	}
 	
 	@Override
Index: TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/WordAnnotationToolbar.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/WordAnnotationToolbar.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/WordAnnotationToolbar.java	(revision 3422)
@@ -831,7 +831,7 @@
 		
 		updateAnnotationWidgetStates();
 		editor.layout(true);
-		ext.getSaveButton().setEnabled(true);
+//		ext.getSaveButton().setEnabled(true);
 		return true;
 	}
 	
Index: TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/SimpleKRAnnotation.java
===================================================================
--- TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/SimpleKRAnnotation.java	(revision 3421)
+++ TXM/trunk/org.txm.annotation.kr.rcp/src/org/txm/annotation/kr/rcp/concordance/SimpleKRAnnotation.java	(revision 3422)
@@ -388,7 +388,7 @@
 		updateAnnotationWidgetStates();
 		editor.layout(true);
 		
-		ext.getSaveButton().setEnabled(true);
+//		ext.getSaveButton().setEnabled(true);
 		return true;
 	}
 	
